function love.load() -- Loads all the other scripts and defines all the functions from said scripts

	local Y = love.filesystem.load('physics.lua')
  local X = love.filesystem.load('graphics.lua')
  local T = love.filesystem.load('strManip.lua')

  physics = Y
  graphics = X
  strManip = T

  print = graphics(0).print -- Graphics functions
  clear = graphics(0).clear
  color = graphics(0).color
  drawEllipse = graphics(0).drawEllipse
  drawEllipseF = graphics(0).drawEllipseF
  drawBox3D = graphics(0).drawBox3D
  drawLine = graphics(0).drawLine

  split = strManip(0).split -- String manipulation functions
  starts = strManip(0).starts
  ends = strManip(0).ends

  onStartup()
end


function readConfigFile(_index) -- Returns the config file's data
  conversionStep1 = {}
  conversionStep2 = {}

  local config = love.filesystem.read("config.txt") -- Get the content of config.txt

  conversionStep1 = split(config,"\n") -- Split all the config options into a table

  for i=1,#conversionStep1 do -- Split the config option name and the value
    conversionStep2[i] = split(conversionStep1[i], "%s")
  end

  return conversionStep2[_index]
end

function love.update(dt) -- Function is called every frame
  onTick(dt)
end


function love.draw() -- Function is called every time the script draws to the screen
  onDraw()
end



function onStartup() -- Runs on application startup
  objArray = {}
  points1 = {{-40, -40, -40}, {-40, -40, 40}, {-40, 40, -40}, {-40, 40, 40}, {40, -40, -40}, {40, -40, 40}, {40, 40, -40}, {40, 40, 40}}
  lines1 = {{1,2},{2,4},{4,3},{3,1},{5,6},{6,8},{8,7},{7,5},{1,5},{2,6},{3,7},{4,8}}


  points2 = {{-40, -40, -40}, {-40, -40, 40}, {-40, 40, -40}, {-40, 40, 40}, {40, -40, -40}, {40, -40, 40}, {40, 40, -40}, {40, 40, 40}}
  lines2 = {{1, 2, 3}, {2, 4, 3}, {4, 3, 8}, {8, 3, 4}, {8, 3, 7}, {6, 1, 2}, {6, 1, 5}, {5, 3, 1}, {5, 7, 3}, {8, 6, 2}, {8, 2, 3}}
  degX = 0
  degY = 0
  degZ = 0
end


function onTick(dt)
  if love.keyboard.isDown("w") then
    degX = degX + dt / 10
  end
  if love.keyboard.isDown("s") then
    degX = degX - dt / 10
  end

  if love.keyboard.isDown("a") then
    degY = degY - dt / 10
  end
  if love.keyboard.isDown("d") then
    degY = degY + dt / 10
  end

  points1 = rotPointsZ(degZ, points1)
  points1 = rotPointsX(degX, points1)
  points1 = rotPointsY(degY, points1)
  points2 = rotPointsZ(degZ, points2)
  points2 = rotPointsX(degX, points2)
  points2 = rotPointsY(degY, points2)
end

function onDraw()
  print(tostring(readConfigFile(1)[1]), 0, 0)
  print(tostring(readConfigFile(1)[2]), 0, 10)


  drawBox3D(120, 120, "onlyLines", points1, lines1, 4, color(0, 255, 0), color(0, 0, 255), color(0, 0, 0))
  drawBox3D(300, 120, "onlyPoints", points1, lines1, 4, color(0, 255, 0), color(0, 0, 255), color(0, 0, 0))
  drawBox3D(300, 300, "e", points2, lines2, 4, color(0, 255, 0), color(0, 0, 255), color(255, 255, 255))
end